
using System;
using System.Data.SQLite;

namespace Dizzy
{


	public class GlobalConfig
	{
		public string user, password;
		private SQLiteConnection conn;
		
		public GlobalConfig ()
		{
			conn = new SQLiteConnection ("Data Source=" + DataBaseName () + ";Version=3;");
			// Controlliamo che il database sia correttamente
			// inizializzato. 
			Init ();
		}
		
		public string GetValue(string field)
		{
			string val;
			
			SQLiteCommand sqlCmd;
			this.conn.Open ();
			sqlCmd = this.conn.CreateCommand ();
			
			sqlCmd.CommandText = "SELECT value FROM config WHERE field = '" + field + "';";
			SQLiteDataReader reader = sqlCmd.ExecuteReader ();
			if (reader.Read())
				val = reader.GetString(0);
			else
				val  = "";
			this.conn.Close ();
			return val;
			
		}
		
		public void InsertValue(string field, string val)
		{
			SQLiteCommand sqlCmd;
			
			this.conn.Open ();
			sqlCmd = this.conn.CreateCommand ();
			
			sqlCmd.CommandText = "INSERT OR REPLACE INTO config VALUES ('" + field + "', '" + val + "');";
			sqlCmd.ExecuteNonQuery ();
			this.conn.Close ();
		}
		
		protected void Init ()
		{
			SQLiteCommand sqlCmd;
			this.conn.Open ();
			sqlCmd = this.conn.CreateCommand ();
			
			sqlCmd.CommandText = "SELECT * FROM sqlite_master WHERE type='table';";
			SQLiteDataReader reader = sqlCmd.ExecuteReader ();
			
			if(!reader.HasRows)
			{
				this.conn.Close ();
				InitialSetup ();
			}
			else 
				this.conn.Close ();
		}
		
		protected void InitialSetup ()
		{
			// Dobbiamo creare la struttura del database
			SQLiteCommand sqlCmd;
			this.conn.Open ();
			
			// Tabelle delle configurazioni
			sqlCmd = this.conn.CreateCommand ();
			sqlCmd.CommandText = "CREATE TABLE config (field TEXT, value TEXT);";
			sqlCmd.ExecuteNonQuery ();
			
			// Tabella della lista
			sqlCmd = this.conn.CreateCommand ();
			sqlCmd.CommandText = "CREATE TABLE list (path TEXT, user TEXT);";
			sqlCmd.ExecuteNonQuery ();
			
			this.conn.Close ();
		}
		
		protected string DataBaseName ()
		{
			string dir = "";
			if (System.Environment.OSVersion.ToString ().Contains("Windows"))
			{
				
				System.Reflection.Assembly a = System.Reflection.Assembly.GetEntryAssembly ();
				dir = System.IO.Path.GetDirectoryName (a.Location);
				
			}
			else // Assumiamo qualcosa di Unix-like
			{
				dir = System.Environment.GetEnvironmentVariable("HOME");
				dir += System.IO.Path.DirectorySeparatorChar + ".dizzy";
			}
			if (!System.IO.Directory.Exists(dir))
				System.IO.Directory.CreateDirectory (dir);
			
			string db = dir + System.IO.Path.DirectorySeparatorChar + "config.sqlite";
			if (!System.IO.File.Exists (db))
				System.IO.File.Create (db);
			return db;
		}
	}
	
}
